var express = require('express');
var path = require('path');
var favicon = require('static-favicon');
var logger = require('morgan');
var cookieParser = require('cookie-parser');
var bodyParser = require('body-parser');

var uuid = require('node-uuid');
var exec = require('child_process').exec;
var fs = require('fs');

// Sentry Integration
var raven = require('raven');
var sentryClient = new raven.Client('https://94c20505156548ce9901c4d640d93306:3970b2d7d39c45e296667377fb13755a@sentry.edyou.eu/6');
sentryClient.patchGlobal();


/* General Server init */

var serverData = null;
var clientIo = null;
var cIo = require('socket.io-client');

var socketInitiated = false;
var t1;

/* Socket Server Section start */
var io = require('socket.io').listen(4000);

io.on('connection', function (socket) {

  var auth = false;

  socket.on('auth', function(data)
  {

    if(data.user == null || data.pass == null)
    {
      socket.emit('authenticate');
    }

    checkAuth(data.user, data.pass, function(result)
    {
      if(result === true)
      {
        exec('/usr/sbin/udm users/user list --filter username='+data.user+' | grep groups', function(error, stdout, stderr)
        {
          if(stdout.indexOf('Administrators') >= 0 || stdout.indexOf('Admins') >= 0)
          {
            auth = true;
            socket.emit('authenticated', data);
            socket.emit('allowed', { status: serverData.allowConnections });
            console.log(time()+" Sende Response an Browser");
          }
          else
          {
            socket.emit('authenticate');
          }
        });
      }
      else
      {
        socket.emit('authenticate');
      }
    });
  });

  socket.on('ready2Auth', function()
  {
    if(t1 == null)
    {
      t1 = setTimeout(function()
      {
        socket.emit('authenticate');
      }, 250);
    }
  });

  socket.on('isAllowed', function()
  {
    socket.emit('allowed', { status: serverData.allowConnections });
  });

  socket.on('allowConnection', function (data) {

    if(auth === false)
    {
      socket.emit('authenticate');
      return;
    }

    serverData.allowConnections = data;

    if(data)
    {
      socketInit();
    }
    else
    {
      console.log(time() + " Verbindung wird getrennt");
      clientIo.disconnect();
    }

    config(function(){}, serverData);

    //Versuchen den Socket neu zu initialisieren
  });

  socket.on('getConnectionStatus', function () {
    if(clientIo == null)
    {
      socket.emit('connectionStatus', false);
      return;
    }

    socket.emit('connectionStatus', clientIo.connected);
  });

  socket.on('getDomain', function () {
    if(clientIo == null)
    {
      socket.emit('domain', false );
      return;
    }

    socket.emit('domain', serverData.domain );
  });

  socket.on("getLog", function(){

    if(auth === false)
    {
      socket.emit('authenticate', {});
      return;
    }

    var readLog = function()
    {
      exec('tail -n 30 /var/log/edyou-connector.log', function(error, stdout, stderr)
      {
        if (error || stdout == undefined) {
          socket.emit('log', "");
          return;
        }

        socket.emit('log', stdout);
      });
    }

    readLog();

    fs.watch('/var/log/edyou-connector.log', function()
    {
      readLog();
    });

  });
});

/* Socket Section end */

var generalInit = function(callback)
{
  config(function(data)
  {
    if(data === false)
    {
     fullInit(callback);
      return;
    }
    else
    {
      serverData = data;
      callback();
      return;
    }
  });
}

var fullInit = function(callback)
{
  var tempConf = {};
  //Generate UUID
  tempConf.id = uuid.v4();
  //Read Domain
  exec('/usr/sbin/ucr get ldap/base', function(error, stdout, stderr)
  {
    if(error !== null)
    {
      console.log(time()+" Ldap Base konnte nicht ermittelt werden: "+stderr);
      return false;
    }
    //Domain erhalten
    tempConf.domain = replaceAll(stdout, 'dc=','').trim().split(',').join('.');

    //Allow Connections
    tempConf.allowConnections = false;

    serverData = tempConf;
    config(callback, tempConf);

  });
}

var socketInit = function()
{

  if(serverData.allowConnections === false)
  {

    if(cIo.connected)
    {
      cIo.disconnect();
    }

    return;
  }

  clientIo = cIo.connect('https://sync.edyou.eu',{'forceNew': true });

  /* Socket Client Section start */

//var clientSocket = io.connect('https://pads.edyou.eu', { resource: 'sync/server.io' });

  clientIo.on('connect', function () {
    console.log(time()+" Verbindung zu EDYOU hergestellt");
    io.emit('connectionStatus', true);
  });

  clientIo.on('disconnect', function()
  {
    console.log(time()+" Verbindung zu EDYOU verloren");
    io.emit('connectionStatus', false);
  });

  // Wenn der Server Connected wird er zuerst nach seiner Identification gefragt
  // und in einen seperaten raum verschoben
  clientIo.on('identify', function()
  {
    clientIo.emit('identification', serverData);
  });

  clientIo.on('auth', function(data)
  {
    console.log(time()+" Incoming Auth");

    //PAM Auth durchführen
    checkAuth(data.user, data.pass, function(succ)
    {
      if(succ === true)
      {
        exec('/usr/sbin/udm users/user list --filter username='+data.user, function(error, stdout, stderr)
        {
          if(error !== null)
          {
            console.log(time()+" gruppe konnte nicht ermittelt werden: "+stderr);
            clientIo.emit('auth-reply', {user: data.user, success: false, error: stderr});
            return false;
          }

          console.log(time()+ " ermittle Zusatzsdaten...");
          var str = stdout;
          var re = /groups:[\s](cn=[a-zA-Z0-9= ,]*)/g;
          var matches = [], found;
          while (found = re.exec(str)) {
            matches.push(found[1]);
            re.lastIndex -= found[0].split(':')[1].length;
          }

          var re2 = /lastname:[\s]([a-zA-Z0-9= ,]*)/g;
          found = re2.exec(str);
          var ln = found[1];

          var re3 = /firstname:[\s]([a-zA-Z0-9= ,]*)/g;
          found = re3.exec(str);
          var fn = found[1];

          console.log(time() + " Sende Reponse")
          //Send Response:
          clientIo.emit('auth-reply', {user: data.user, success: true, groups: matches, firstname: fn, lastname:ln});
          return;

        });

      }
      else
      {
        clientIo.emit('auth-reply', {user: data.user, success: false, error: succ});
      }
    })
  });

  socketInitiated = true;
}

/**
 * Testste Authentifizierung gegen den LDAP server
 * @param username
 * @param password
 * @param callback
 */
var checkAuth = function(username, password, callback)
{
  var pam = require('authenticate-pam');
  pam.authenticate(username, password, function(err) {
    if(err) {
      console.log(time()+" "+err);
      callback(err);
      return;
    }
    else {
      console.log(time()+" "+username+" authenticated!");
      callback(true);
      return;
    }
  });
}

var config = function(callback, conf)
{
  if(typeof conf == "undefined")
  {
    fs.readFile('/opt/edyou/config.json', 'utf8', function (err,data) {
      if (err || data == undefined) {
        callback(false);
        return;
      }
      console.log(time()+" Config: "+data);
      callback(JSON.parse(data));
    });
  }
  else
  {
    fs.writeFile('/opt/edyou/config.json', JSON.stringify(conf), function(err) {
      if(err) {
        callback(false);
      } else {
        callback(true);
      }
    });
  }
}

function escapeRegExp(string) {
  return string.replace(/([.*+?^=!:${}()|\[\]\/\\])/g, "\\$1");
}

function replaceAll(string, find, replace) {
  return string.replace(new RegExp(escapeRegExp(find), 'g'), replace);
}

generalInit(socketInit);


function checkTime(i) {
  if (i < 10) {
    i = "0" + i;
  }
  return i;
}

function time() {
  var today = new Date();
  var h = today.getHours();
  var m = today.getMinutes();
  var s = today.getSeconds();
  var d = today.getDate()
  var M = today.getMonth();
  var y = today.getFullYear();

  // add a zero in front of numbers<10
  m = checkTime(m);
  s = checkTime(s);
  M = checkTime(M+1);
  d = checkTime(d);
  return d + "." + M + "." + y + " " + h + ":" + m + ":" + s;
}