var server = window.location.host;
var edyouConnect = angular.module('edyouConnect', [])
  .controller('installCtrl', ['$scope',
    function ($scope) {
      var socket = io.connect('http://'+ server +':4000');

      socket.on('allowed', function(data)
      {
        if(data.status)
        {
          window.location.href="/edyou/index.html";
        }
      });

      setTimeout(function()
      {
        remoteAuth(socket);
      }, 250);

      socket.on('authenticated', function(data)
      {
        $scope.agree;

        $scope.test = "Test";
        $scope.acceptTerms = function()
        {
          socket.emit('allowConnection', true);
          window.location.href="/edyou/index.html";
        }
      });

      socket.on('authenticate', function()
      {
        window.location.href="/edyou/index.html"
      });

    }
  ])
  .controller('dashboardCtrl', ['$scope',
    function ($scope) {
      var socket = io.connect('http://'+ server +':4000');

      remoteAuth(socket);

      socket.on('authenticated', function(data)
      {
        sessionStorage.setItem('user', data.user);
        sessionStorage.setItem('pass', data.pass);


        $scope.online = false;
        $scope.domain = "...loading...";
        $scope.log = "";

        $scope.declineTerms = function()
        {
          socket.emit('allowConnection', false);
          window.location.href="/edyou/index.html";
        }

        //Daten fetchen
        socket.emit('getLog', true);
        socket.emit('getDomain', true);
        socket.emit('getConnectionStatus', true);

        socket.on('log', function(data)
        {
          $scope.$apply(function()
          {
            $scope.log = data;
          });
        });

        socket.on('domain', function(data)
        {
          $scope.$apply(function()
          {
            $scope.domain = data;
          });
        });

        socket.on('connectionStatus', function(data)
        {
          $scope.$apply(function()
          {
            $scope.online = data;
          });
        });

      });

      socket.on('authenticate', function()
      {
        window.location.href="/edyou/index.html"
      });
    }
  ])
  .controller('redirectCtrl', ['$scope',
    function ($scope) {
      var socket = io.connect('http://'+ server +':4000');

      $scope.username = "";
      $scope.password = "";

      $scope.alert = false;

      if(sessionStorage.getItem('user') != null && sessionStorage.getItem('pass') != null)
      {
        remoteAuth(socket);
      }
      else
      {

        $scope.login = function()
        {
          var userdata = {user: $scope.username, pass: $scope.password};

          socket.emit('auth', userdata);
        }

      }

      socket.on('authenticated', function(data)
      {
        socket.emit('isAllowed');

        sessionStorage.setItem('user', data.user);
        sessionStorage.setItem('pass', data.pass);

        socket.on('allowed', function (data) {
          if(data.status === true)
          {
            window.location.href="/edyou/dashboard.html"
          }
          else
          {
            window.location.href="/edyou/install.html"
          }
        });
      });

      socket.on('authenticate', function()
      {
        $scope.$apply(function()
        {
          $scope.username = "";
          $scope.password = "";
          $scope.alert = true;
        });

      });
    }
  ]);

var remoteAuth = function(socket)
{
  var userdata = {user: sessionStorage.getItem('user'), pass: sessionStorage.getItem('pass')};

  socket.emit('auth', userdata);
}

